"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const rxjs_1 = require("rxjs");
const apis_1 = require("../infrastructure/apis");
const runtime_1 = require("./runtime");
class ContractClientHttp {
    /**
     * Constructor
     * @param url
     */
    constructor(configuration) {
        this.contractRoutesApi = new apis_1.ContractClientApi(new runtime_1.Configuration(configuration));
    }
    ls() {
        return rxjs_1.from(this.contractRoutesApi.ls().then(cidListWrap => cidListWrap.ids));
    }
    getContract(drive) {
        return rxjs_1.from(this.contractRoutesApi.getContract({ argDrive: drive }).then(contractWrap => contractWrap.contract));
    }
    compose(space, duration, replicas, minReplicators, subscriptionPrice, numberSubscriptionPeriods, percentApprovers, privateKey) {
        return rxjs_1.from(this.contractRoutesApi.compose({
            argSpace: space,
            argDuration: duration,
            replicas,
            minReplicators,
            subscriptionPrice,
            numberSubscriptionPeriods,
            percentApprovers,
            privateKey
        }).then(contractWrap => contractWrap.contract));
    }
    verify(drive) {
        return rxjs_1.from(this.contractRoutesApi.verify({ argDrive: drive }));
    }
    finish(drive) {
        return rxjs_1.from(this.contractRoutesApi.finish({ argDrive: drive }));
    }
    ammends(drive) {
        return rxjs_1.from(this.contractRoutesApi.ammends({ argDrive: drive }).then(contractWrap => contractWrap.contract));
    }
}
exports.ContractClientHttp = ContractClientHttp;
//# sourceMappingURL=ContractClientHttp.js.map