import { Observable } from 'rxjs';
import { HTTPBody, ConfigurationParameters } from './runtime';
import { Stat } from './models';
export declare class DriveFsHttp {
    /**
     * Constructor
     * @param url
     */
    constructor(configuration: ConfigurationParameters);
    add(cid: string, dstPath: string, body: HTTPBody, flush?: boolean): Observable<string>;
    cp(cid: string, srcPath: string, dstPath: string, flush?: boolean): Observable<void>;
    flush(cid: string): Observable<void>;
    getAsText(cid: string, path: string): Observable<string>;
    getAsBlob(cid: string, path: string): Observable<Blob>;
    getAsResponse(cid: string, path: string): Observable<Response>;
    fileAsText(cid: string, cidFile: string): Observable<string>;
    fileAsBlob(cid: string, cidFile: string): Observable<Blob>;
    fileAsResponse(cid: string, cidFile: string): Observable<Response>;
    ls(cid: string, path: string): Observable<Stat[]>;
    mkDir(cid: string, path: string, flush?: boolean): Observable<void>;
    mv(cid: string, srcPath: string, dstPath: string, flush?: boolean): Observable<void>;
    rm(cid: string, path: string, flush?: boolean): Observable<void>;
    stat(cid: string, path: string): Observable<Stat>;
}
