"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const rxjs_1 = require("rxjs");
const apis_1 = require("../infrastructure/apis");
const runtime_1 = require("./runtime");
class NetworkHttp {
    /**
     * Constructor
     * @param url
     */
    constructor(configuration) {
        this.network = new apis_1.NetworkApi(new runtime_1.Configuration(configuration));
    }
    id() {
        return rxjs_1.from(this.network.getid().then(peerIdWrap => peerIdWrap.iD));
    }
    addresses() {
        return rxjs_1.from(this.network.addresses().then(addrListWrap => addrListWrap.addrs));
    }
    peers() {
        return rxjs_1.from(this.network.peers().then(peerListWrap => peerListWrap.peers));
    }
    /**
     * @param address single address as returned from addresses()
     */
    connect(address) {
        return rxjs_1.from(this.network.connect({ argAddr: address }));
    }
    disconnect(address) {
        return rxjs_1.from(this.network.disconnect({ argAddr: address }));
    }
}
exports.NetworkHttp = NetworkHttp;
//# sourceMappingURL=NetworkHttp.js.map