/**
 * DFMS API
 * DFMS node HTTP API. [Reference implementation in GO](https://github.com/proximax-storage/go-xpx-dfms-api-http) [API definition](https://github.com/proximax-storage/go-xpx-dfms-api)  API does not tries to follow idiomatic REST or other API patterns for reasons.
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import * as runtime from '../runtime';
import { CidListWrap, ContractWrap, VerifyResult } from '../models';
export interface AmmendsRequest {
    argDrive: string;
}
export interface ComposeRequest {
    argSpace: number;
    argDuration: string;
    replicas?: number;
    minReplicators?: number;
    subscriptionPrice?: number;
    numberSubscriptionPeriods?: number;
    percentApprovers?: number;
    privateKey?: string;
}
export interface FinishRequest {
    argDrive: string;
}
export interface GetContractRequest {
    argDrive: string;
}
export interface VerifyRequest {
    argDrive: string;
}
/**
 *
 */
export declare class ContractClientApi extends runtime.BaseAPI {
    /**
     * Creates subscription for Drive Contract updates/corrections of any contract from the network by ID.
     * Ammendments subscription
     */
    ammendsRaw(requestParameters: AmmendsRequest): Promise<runtime.ApiResponse<ContractWrap>>;
    /**
     * Creates subscription for Drive Contract updates/corrections of any contract from the network by ID.
     * Ammendments subscription
     */
    ammends(requestParameters: AmmendsRequest): Promise<ContractWrap>;
    /**
     * Compose synchronously announces invites to the Network with current node as an owner and tries to find members which agrees on specified parameters and options. It does not guarantee success on resolving members. On success persists contract locally and gives ability to use DriveFS.
     * Creates new Drive contract
     */
    composeRaw(requestParameters: ComposeRequest): Promise<runtime.ApiResponse<ContractWrap>>;
    /**
     * Compose synchronously announces invites to the Network with current node as an owner and tries to find members which agrees on specified parameters and options. It does not guarantee success on resolving members. On success persists contract locally and gives ability to use DriveFS.
     * Creates new Drive contract
     */
    compose(requestParameters: ComposeRequest): Promise<ContractWrap>;
    /**
     * Finish contract.
     * Finish contract
     */
    finishRaw(requestParameters: FinishRequest): Promise<runtime.ApiResponse<void>>;
    /**
     * Finish contract.
     * Finish contract
     */
    finish(requestParameters: FinishRequest): Promise<void>;
    /**
     * Searches for Drive Contract information over the network.
     * Get Drive contract infromation
     */
    getContractRaw(requestParameters: GetContractRequest): Promise<runtime.ApiResponse<ContractWrap>>;
    /**
     * Searches for Drive Contract information over the network.
     * Get Drive contract infromation
     */
    getContract(requestParameters: GetContractRequest): Promise<ContractWrap>;
    /**
     * Lists all the contracts in which Node participates as an owner or a member
     * List Drive contracts node aware of
     */
    lsRaw(): Promise<runtime.ApiResponse<CidListWrap>>;
    /**
     * Lists all the contracts in which Node participates as an owner or a member
     * List Drive contracts node aware of
     */
    ls(): Promise<CidListWrap>;
    /**
     * Initiates verification round between replicators.
     * Contract verify
     */
    verifyRaw(requestParameters: VerifyRequest): Promise<runtime.ApiResponse<Array<VerifyResult>>>;
    /**
     * Initiates verification round between replicators.
     * Contract verify
     */
    verify(requestParameters: VerifyRequest): Promise<Array<VerifyResult>>;
}
