"use strict";
/* tslint:disable */
/* eslint-disable */
/**
 * DFMS API
 * DFMS node HTTP API. [Reference implementation in GO](https://github.com/proximax-storage/go-xpx-dfms-api-http) [API definition](https://github.com/proximax-storage/go-xpx-dfms-api)  API does not tries to follow idiomatic REST or other API patterns for reasons.
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
Object.defineProperty(exports, "__esModule", { value: true });
const runtime = require("../runtime");
const models_1 = require("../models");
const abort_controller_1 = require("abort-controller");
/*
export interface AmmendsRequest {
    argDrive: string;
}

export interface ComposeRequest {
    argSpace: number;
    argDuration: string;
    replicas?: number;
    minReplicators?: number;
    subscriptionPrice?: number;
    numberSubscriptionPeriods?: number;
    percentApprovers?: number;
    privateKey?: string;
}

export interface FinishRequest {
    argDrive: string;
}

export interface GetContractRequest {
    argDrive: string;
}

export interface VerifyRequest {
    argDrive: string;
}
*/
/**
 *
 */
class ContractReplicatorApi extends runtime.BaseAPI {
    /**
     * Accept joins contract by it\'s id. Can join only contracts awaiting new members.
     * Accept joins contract
     */
    async acceptRaw(requestParameters) {
        if (requestParameters.argDrive === null || requestParameters.argDrive === undefined) {
            throw new runtime.RequiredError('argDrive', 'Required parameter requestParameters.argDrive was null or undefined when calling accept.');
        }
        const queryParameters = {};
        queryParameters['arg'] = requestParameters.argDrive;
        const headerParameters = {};
        const response = await this.request({
            path: `/contract/accept`,
            method: 'POST',
            headers: headerParameters,
            query: queryParameters,
        });
        return new runtime.VoidApiResponse(response);
    }
    /**
     * Accept joins contract by it\'s id. Can join only contracts awaiting new members.
     * Accept joins contract
     */
    async accept(requestParameters) {
        await this.acceptRaw(requestParameters);
    }
    /**
     * Establishes persitent connection and sends json value through it to the requester as long as new updates appear.
     * Show accepted contracts
     */
    async acceptedRaw() {
        // async acceptedRaw(): Promise<runtime.ApiResponse<ContractWrap>> {
        const abortController = new abort_controller_1.AbortController();
        const signal = abortController.signal;
        const queryParameters = {};
        const headerParameters = {};
        const response = await this.request({
            path: `/contract/accepted`,
            method: 'POST',
            headers: headerParameters,
            query: queryParameters,
            signal: signal
        });
        return { response, abortController };
        // return new runtime.JSONApiResponse(response, (jsonValue) => ContractWrapFromJSON(jsonValue));
    }
    /**
     * Establishes persitent connection and sends json value through it to the requester as long as new updates appear.
     * Show accepted contracts
     */
    async accepted() {
        const response = await this.acceptedRaw();
        return new runtime.JSONApiResponse(response.response, (jsonValue) => models_1.ContractWrapFromJSON(jsonValue)).value();
        // return await response.value();
    }
    async acceptedAsStream() {
        const response = await this.acceptedRaw();
        return response.response.body;
    }
    /**
     * Creates subscription for Drive Contract updates/corrections of any contract from the network by ID.
     * Ammendments subscription
     */
    async ammendsRaw(requestParameters) {
        if (requestParameters.argDrive === null || requestParameters.argDrive === undefined) {
            throw new runtime.RequiredError('argDrive', 'Required parameter requestParameters.argDrive was null or undefined when calling ammends.');
        }
        const queryParameters = {};
        queryParameters['arg'] = requestParameters.argDrive;
        const headerParameters = {};
        const response = await this.request({
            path: `/contract/ammends`,
            method: 'POST',
            headers: headerParameters,
            query: queryParameters,
        });
        return new runtime.JSONApiResponse(response, (jsonValue) => models_1.ContractWrapFromJSON(jsonValue));
    }
    /**
     * Creates subscription for Drive Contract updates/corrections of any contract from the network by ID.
     * Ammendments subscription
     */
    async ammends(requestParameters) {
        const response = await this.ammendsRaw(requestParameters);
        return await response.value();
    }
    /**
     * Compose synchronously announces invites to the Network with current node as an owner and tries to find members which agrees on specified parameters and options. It does not guarantee success on resolving members. On success persists contract locally and gives ability to use DriveFS.
     * Creates new Drive contract
     */
    async composeRaw(requestParameters) {
        if (requestParameters.argSpace === null || requestParameters.argSpace === undefined) {
            throw new runtime.RequiredError('argSpace', 'Required parameter requestParameters.argSpace was null or undefined when calling compose.');
        }
        if (requestParameters.argDuration === null || requestParameters.argDuration === undefined) {
            throw new runtime.RequiredError('argDuration', 'Required parameter requestParameters.argDuration was null or undefined when calling compose.');
        }
        const queryParameters = {};
        queryParameters['arg'] = [requestParameters.argSpace, requestParameters.argDuration];
        if (requestParameters.replicas !== undefined) {
            queryParameters['replicas'] = requestParameters.replicas;
        }
        if (requestParameters.minReplicators !== undefined) {
            queryParameters['min-replicators'] = requestParameters.minReplicators;
        }
        if (requestParameters.subscriptionPrice !== undefined) {
            queryParameters['subscription-price'] = requestParameters.subscriptionPrice;
        }
        if (requestParameters.numberSubscriptionPeriods !== undefined) {
            queryParameters['number-subscription-periods'] = requestParameters.numberSubscriptionPeriods;
        }
        if (requestParameters.percentApprovers !== undefined) {
            queryParameters['percent-approvers'] = requestParameters.percentApprovers;
        }
        if (requestParameters.privateKey !== undefined) {
            queryParameters['private-key'] = requestParameters.privateKey;
        }
        const headerParameters = {};
        const response = await this.request({
            path: `/contract/compose`,
            method: 'POST',
            headers: headerParameters,
            query: queryParameters,
        });
        return new runtime.JSONApiResponse(response, (jsonValue) => models_1.ContractWrapFromJSON(jsonValue));
    }
    /**
     * Compose synchronously announces invites to the Network with current node as an owner and tries to find members which agrees on specified parameters and options. It does not guarantee success on resolving members. On success persists contract locally and gives ability to use DriveFS.
     * Creates new Drive contract
     */
    async compose(requestParameters) {
        const response = await this.composeRaw(requestParameters);
        return await response.value();
    }
    /**
     * Finish contract.
     * Finish contract
     */
    async finishRaw(requestParameters) {
        if (requestParameters.argDrive === null || requestParameters.argDrive === undefined) {
            throw new runtime.RequiredError('argDrive', 'Required parameter requestParameters.argDrive was null or undefined when calling finish.');
        }
        const queryParameters = {};
        queryParameters['arg'] = requestParameters.argDrive;
        const headerParameters = {};
        const response = await this.request({
            path: `/contract/finish`,
            method: 'POST',
            headers: headerParameters,
            query: queryParameters,
        });
        return new runtime.VoidApiResponse(response);
    }
    /**
     * Finish contract.
     * Finish contract
     */
    async finish(requestParameters) {
        await this.finishRaw(requestParameters);
    }
    /**
     * Searches for Drive Contract information over the network.
     * Get Drive contract infromation
     */
    async getContractRaw(requestParameters) {
        if (requestParameters.argDrive === null || requestParameters.argDrive === undefined) {
            throw new runtime.RequiredError('argDrive', 'Required parameter requestParameters.argDrive was null or undefined when calling getContract.');
        }
        const queryParameters = {};
        queryParameters['arg'] = requestParameters.argDrive;
        const headerParameters = {};
        const response = await this.request({
            path: `/contract/get`,
            method: 'POST',
            headers: headerParameters,
            query: queryParameters,
        });
        return new runtime.JSONApiResponse(response, (jsonValue) => models_1.ContractWrapFromJSON(jsonValue));
    }
    /**
     * Searches for Drive Contract information over the network.
     * Get Drive contract infromation
     */
    async getContract(requestParameters) {
        const response = await this.getContractRaw(requestParameters);
        return await response.value();
    }
    /**
     * Creates subscription for new contract invitations. Main use case is to have external contract acceptance logic.
     * Subscribe to new contracts
     */
    async invitesRaw() {
        // async invitesRaw(): Promise<runtime.ApiResponse<InviteWrap>> {
        const abortController = new abort_controller_1.AbortController();
        const signal = abortController.signal;
        const queryParameters = {};
        const headerParameters = {};
        const response = await this.request({
            path: `/contract/invites`,
            method: 'POST',
            headers: headerParameters,
            query: queryParameters,
            signal: signal
        });
        return { response, abortController };
        // return new runtime.JSONApiResponse(response, (jsonValue) => InviteWrapFromJSON(jsonValue));
    }
    /**
     * Creates subscription for new contract invitations. Main use case is to have external contract acceptance logic.
     * Subscribe to new contracts
     */
    async invites() {
        const response = await this.invitesRaw();
        return new runtime.JSONApiResponse(response.response, (jsonValue) => models_1.InviteWrapFromJSON(jsonValue)).value();
        // return await response.value();
    }
    async invitesAsStream() {
        const response = await this.invitesRaw();
        return response.response.body;
    }
    /**
     * Lists all the contracts in which Node participates as an owner or a member
     * List Drive contracts node aware of
     */
    async lsRaw() {
        const queryParameters = {};
        const headerParameters = {};
        const response = await this.request({
            path: `/contract/ls`,
            method: 'POST',
            headers: headerParameters,
            query: queryParameters,
        });
        return new runtime.JSONApiResponse(response, (jsonValue) => models_1.CidListWrapFromJSON(jsonValue));
    }
    /**
     * Lists all the contracts in which Node participates as an owner or a member
     * List Drive contracts node aware of
     */
    async ls() {
        const response = await this.lsRaw();
        return await response.value();
    }
    /**
     * Initiates verification round between replicators.
     * Contract verify
     */
    async verifyRaw(requestParameters) {
        if (requestParameters.argDrive === null || requestParameters.argDrive === undefined) {
            throw new runtime.RequiredError('argDrive', 'Required parameter requestParameters.argDrive was null or undefined when calling verify.');
        }
        const queryParameters = {};
        queryParameters['arg'] = requestParameters.argDrive;
        const headerParameters = {};
        const response = await this.request({
            path: `/contract/verify`,
            method: 'POST',
            headers: headerParameters,
            query: queryParameters,
        });
        return new runtime.JSONApiResponse(response, (jsonValue) => jsonValue.map(models_1.VerifyResultFromJSON));
    }
    /**
     * Initiates verification round between replicators.
     * Contract verify
     */
    async verify(requestParameters) {
        const response = await this.verifyRaw(requestParameters);
        return await response.value();
    }
}
exports.ContractReplicatorApi = ContractReplicatorApi;
//# sourceMappingURL=ContractReplicatorApi.js.map