/**
 * DFMS API
 * DFMS node HTTP API. [Reference implementation in GO](https://github.com/proximax-storage/go-xpx-dfms-api-http) [API definition](https://github.com/proximax-storage/go-xpx-dfms-api)  API does not tries to follow idiomatic REST or other API patterns for reasons.
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import * as runtime from '../runtime';
import { CidWrap, StatListWrap, StatWrap } from '../models';
export interface DriveAddRequest {
    argDrive: string;
    argDst: string;
    body: runtime.HTTPBody;
    flush?: boolean;
}
export interface DriveCpRequest {
    argDrive: string;
    argSrc: string;
    argDst: string;
    flush?: boolean;
}
export interface DriveFileRequest {
    argDrive: string;
    argFileCid: string;
}
export interface DriveFlushRequest {
    argDrive: string;
}
export interface DriveGetRequest {
    argDrive: string;
    argSrc: string;
}
export interface DriveLsRequest {
    argDrive: string;
    argSrc: string;
}
export interface DriveMkdirRequest {
    argDrive: string;
    argSrc: string;
    flush?: boolean;
}
export interface DriveMvRequest {
    argDrive: string;
    argSrc: string;
    argDst: string;
    flush?: boolean;
}
export interface DriveRmRequest {
    argDrive: string;
    argSrc: string;
    flush?: boolean;
}
export interface DriveStatRequest {
    argDrive: string;
    argSrc: string;
}
/**
 *
 */
export declare class DriveFSApi extends runtime.BaseAPI {
    /**
     * Adds to drive a new file/directory and sends it to remote nodes which
     * Add a file/directory
     */
    driveAddRaw(requestParameters: DriveAddRequest): Promise<runtime.ApiResponse<CidWrap>>;
    /**
     * Adds to drive a new file/directory and sends it to remote nodes which
     * Add a file/directory
     */
    driveAdd(requestParameters: DriveAddRequest): Promise<CidWrap>;
    /**
     * Copies a file/directory from a source path to a destination path It does not make the full copy of the file/directory, it just copies the reference
     * Copy file
     */
    driveCpRaw(requestParameters: DriveCpRequest): Promise<runtime.ApiResponse<void>>;
    /**
     * Copies a file/directory from a source path to a destination path It does not make the full copy of the file/directory, it just copies the reference
     * Copy file
     */
    driveCp(requestParameters: DriveCpRequest): Promise<void>;
    /**
     * Returns a file from remote nodes or local store by CID
     * Get file by CID
     */
    driveFileRaw(requestParameters: DriveFileRequest): Promise<Response>;
    /**
     * Returns a file from remote nodes or local store by CID
     * Get file by CID
     */
    driveFileAsText(requestParameters: DriveFileRequest): Promise<string>;
    driveFileAsBlob(requestParameters: DriveFileRequest): Promise<Blob>;
    driveFileAsResponse(requestParameters: DriveFileRequest): Promise<Response>;
    /**
     * Flush pushes state of the local Drive to all replicators
     * Flush drive
     */
    driveFlushRaw(requestParameters: DriveFlushRequest): Promise<runtime.ApiResponse<void>>;
    /**
     * Flush pushes state of the local Drive to all replicators
     * Flush drive
     */
    driveFlush(requestParameters: DriveFlushRequest): Promise<void>;
    /**
     * Return a file/directory from remote nodes or local store by a path
     * Get a file or dir by a path
     */
    driveGetRaw(requestParameters: DriveGetRequest): Promise<Response>;
    /**
     * Return a file/directory from remote nodes or local store by a path
     * Get a file or dir by a path
     */
    driveGetAsText(requestParameters: DriveGetRequest): Promise<string>;
    driveGetAsBlob(requestParameters: DriveGetRequest): Promise<Blob>;
    driveGetAsResponse(requestParameters: DriveGetRequest): Promise<Response>;
    /**
     * Returns information about a file/directory by a given path
     * List files
     */
    driveLsRaw(requestParameters: DriveLsRequest): Promise<runtime.ApiResponse<StatListWrap>>;
    /**
     * Returns information about a file/directory by a given path
     * List files
     */
    driveLs(requestParameters: DriveLsRequest): Promise<StatListWrap>;
    /**
     * Creates a new directory by a given path
     * Make directory
     */
    driveMkdirRaw(requestParameters: DriveMkdirRequest): Promise<runtime.ApiResponse<void>>;
    /**
     * Creates a new directory by a given path
     * Make directory
     */
    driveMkdir(requestParameters: DriveMkdirRequest): Promise<void>;
    /**
     * Moves a file/directory from a source path to a destination path Use also to rename a file/directory
     * Move file
     */
    driveMvRaw(requestParameters: DriveMvRequest): Promise<runtime.ApiResponse<void>>;
    /**
     * Moves a file/directory from a source path to a destination path Use also to rename a file/directory
     * Move file
     */
    driveMv(requestParameters: DriveMvRequest): Promise<void>;
    /**
     * Removes a file/directory by a path
     * Remove file
     */
    driveRmRaw(requestParameters: DriveRmRequest): Promise<runtime.ApiResponse<void>>;
    /**
     * Removes a file/directory by a path
     * Remove file
     */
    driveRm(requestParameters: DriveRmRequest): Promise<void>;
    /**
     * Returns information about a file/directory by a given path
     * File information
     */
    driveStatRaw(requestParameters: DriveStatRequest): Promise<runtime.ApiResponse<StatWrap>>;
    /**
     * Returns information about a file/directory by a given path
     * File information
     */
    driveStat(requestParameters: DriveStatRequest): Promise<StatWrap>;
}
