"use strict";
/* tslint:disable */
/* eslint-disable */
/**
 * DFMS API
 * DFMS node HTTP API. [Reference implementation in GO](https://github.com/proximax-storage/go-xpx-dfms-api-http) [API definition](https://github.com/proximax-storage/go-xpx-dfms-api)  API does not tries to follow idiomatic REST or other API patterns for reasons.
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
Object.defineProperty(exports, "__esModule", { value: true });
const runtime = require("../runtime");
const models_1 = require("../models");
/**
 *
 */
class NetworkApi extends runtime.BaseAPI {
    /**
     * Get all addresses of a node.
     * Node addresses
     */
    async addressesRaw() {
        const queryParameters = {};
        const headerParameters = {};
        const response = await this.request({
            path: `/net/addrs`,
            method: 'POST',
            headers: headerParameters,
            query: queryParameters,
        });
        return new runtime.JSONApiResponse(response, (jsonValue) => models_1.AddrListWrapFromJSON(jsonValue));
    }
    /**
     * Get all addresses of a node.
     * Node addresses
     */
    async addresses() {
        const response = await this.addressesRaw();
        return await response.value();
    }
    /**
     * Connect to a node by it address.
     * Connect to a node
     */
    async connectRaw(requestParameters) {
        if (requestParameters.argAddr === null || requestParameters.argAddr === undefined) {
            throw new runtime.RequiredError('argAddr', 'Required parameter requestParameters.argAddr was null or undefined when calling connect.');
        }
        const queryParameters = {};
        queryParameters['arg'] = requestParameters.argAddr;
        const headerParameters = {};
        const response = await this.request({
            path: `/net/connect`,
            method: 'POST',
            headers: headerParameters,
            query: queryParameters,
        });
        return new runtime.VoidApiResponse(response);
    }
    /**
     * Connect to a node by it address.
     * Connect to a node
     */
    async connect(requestParameters) {
        await this.connectRaw(requestParameters);
    }
    /**
     * Disconnect from a node by its address.
     * Disconnect from a node
     */
    async disconnectRaw(requestParameters) {
        if (requestParameters.argAddr === null || requestParameters.argAddr === undefined) {
            throw new runtime.RequiredError('argAddr', 'Required parameter requestParameters.argAddr was null or undefined when calling disconnect.');
        }
        const queryParameters = {};
        queryParameters['arg'] = requestParameters.argAddr;
        const headerParameters = {};
        const response = await this.request({
            path: `/net/disconnect`,
            method: 'POST',
            headers: headerParameters,
            query: queryParameters,
        });
        return new runtime.VoidApiResponse(response);
    }
    /**
     * Disconnect from a node by its address.
     * Disconnect from a node
     */
    async disconnect(requestParameters) {
        await this.disconnectRaw(requestParameters);
    }
    /**
     * Get ID of a node
     * Get ID
     */
    async getidRaw() {
        const queryParameters = {};
        const headerParameters = {};
        const response = await this.request({
            path: `/net/id`,
            method: 'POST',
            headers: headerParameters,
            query: queryParameters,
        });
        return new runtime.JSONApiResponse(response, (jsonValue) => models_1.PeerIdWrapFromJSON(jsonValue));
    }
    /**
     * Get ID of a node
     * Get ID
     */
    async getid() {
        const response = await this.getidRaw();
        return await response.value();
    }
    /**
     * Get all connected peers.
     * Connected peers
     */
    async peersRaw() {
        const queryParameters = {};
        const headerParameters = {};
        const response = await this.request({
            path: `/net/peers`,
            method: 'POST',
            headers: headerParameters,
            query: queryParameters,
        });
        return new runtime.JSONApiResponse(response, (jsonValue) => models_1.PeerListWrapFromJSON(jsonValue));
    }
    /**
     * Get all connected peers.
     * Connected peers
     */
    async peers() {
        const response = await this.peersRaw();
        return await response.value();
    }
}
exports.NetworkApi = NetworkApi;
//# sourceMappingURL=NetworkApi.js.map