/**
 * DFMS API
 * DFMS node HTTP API. [Reference implementation in GO](https://github.com/proximax-storage/go-xpx-dfms-api-http) [API definition](https://github.com/proximax-storage/go-xpx-dfms-api)  API does not tries to follow idiomatic REST or other API patterns for reasons.
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import * as runtime from '../runtime';
import { CidListWrap, CidResultWrap, ExecutionsWrap, ResultsWrap, SuperContractWrap, SupercontractExec } from '../models';
export interface DeactivateRequest {
    argScId: string;
}
export interface DeployRequest {
    argDrive: string;
    argSrc: string;
}
export interface ExecuteRequest {
    argScId: string;
    argGas: number;
    argFuncName: string;
    argArgsArray?: Array<string>;
}
export interface GetSCRequest {
    argScId: string;
}
export interface LsSCRequest {
    argDrive: string;
}
export interface ResultsRequest {
    argTxId: string;
}
/**
 *
 */
export declare class SuperContractApi extends runtime.BaseAPI {
    /**
     * Deactivate a SuperContract by its ID.
     * Deactivate a SuperContract
     */
    deactivateRaw(requestParameters: DeactivateRequest): Promise<runtime.ApiResponse<void>>;
    /**
     * Deactivate a SuperContract by its ID.
     * Deactivate a SuperContract
     */
    deactivate(requestParameters: DeactivateRequest): Promise<void>;
    /**
     * Deploy a new SuperContract by a file path. Return the SuperContract ID.
     * Deploy a SuperContract
     */
    deployRaw(requestParameters: DeployRequest): Promise<runtime.ApiResponse<CidResultWrap>>;
    /**
     * Deploy a new SuperContract by a file path. Return the SuperContract ID.
     * Deploy a SuperContract
     */
    deploy(requestParameters: DeployRequest): Promise<CidResultWrap>;
    /**
     * Start execution of a SuperContract. Return the Transaction ID.
     * Execute a SuperContract
     */
    executeRaw(requestParameters: ExecuteRequest): Promise<runtime.ApiResponse<SupercontractExec>>;
    /**
     * Start execution of a SuperContract. Return the Transaction ID.
     * Execute a SuperContract
     */
    execute(requestParameters: ExecuteRequest): Promise<SupercontractExec>;
    /**
     * Get all execution results started by a node. Returns Transaction IDs.
     * Execution results
     */
    executionsRaw(): Promise<runtime.ApiResponse<ExecutionsWrap>>;
    /**
     * Get all execution results started by a node. Returns Transaction IDs.
     * Execution results
     */
    executions(): Promise<ExecutionsWrap>;
    /**
     * Get a SuperContract by ID.
     * Get a SuperContract
     */
    getSCRaw(requestParameters: GetSCRequest): Promise<runtime.ApiResponse<SuperContractWrap>>;
    /**
     * Get a SuperContract by ID.
     * Get a SuperContract
     */
    getSC(requestParameters: GetSCRequest): Promise<SuperContractWrap>;
    /**
     * Get all SuperContract on a drive.
     * Get SuperContracts IDs
     */
    lsSCRaw(requestParameters: LsSCRequest): Promise<runtime.ApiResponse<CidListWrap>>;
    /**
     * Get all SuperContract on a drive.
     * Get SuperContracts IDs
     */
    lsSC(requestParameters: LsSCRequest): Promise<CidListWrap>;
    /**
     * Get results of a SuperContract execution by its TxID.
     * Results of a SuperContract execution
     */
    resultsRaw(requestParameters: ResultsRequest): Promise<runtime.ApiResponse<ResultsWrap>>;
    /**
     * Get results of a SuperContract execution by its TxID.
     * Results of a SuperContract execution
     */
    results(requestParameters: ResultsRequest): Promise<ResultsWrap>;
}
