"use strict";
/* tslint:disable */
/* eslint-disable */
/**
 * DFMS API
 * DFMS node HTTP API. [Reference implementation in GO](https://github.com/proximax-storage/go-xpx-dfms-api-http) [API definition](https://github.com/proximax-storage/go-xpx-dfms-api)  API does not tries to follow idiomatic REST or other API patterns for reasons.
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
Object.defineProperty(exports, "__esModule", { value: true });
const runtime = require("../runtime");
const models_1 = require("../models");
/**
 *
 */
class SuperContractApi extends runtime.BaseAPI {
    /**
     * Deactivate a SuperContract by its ID.
     * Deactivate a SuperContract
     */
    async deactivateRaw(requestParameters) {
        if (requestParameters.argScId === null || requestParameters.argScId === undefined) {
            throw new runtime.RequiredError('argScId', 'Required parameter requestParameters.argScId was null or undefined when calling deactivate.');
        }
        const queryParameters = {};
        queryParameters['arg'] = requestParameters.argScId;
        const headerParameters = {};
        const response = await this.request({
            path: `/sc/deactivate`,
            method: 'POST',
            headers: headerParameters,
            query: queryParameters,
        });
        return new runtime.VoidApiResponse(response);
    }
    /**
     * Deactivate a SuperContract by its ID.
     * Deactivate a SuperContract
     */
    async deactivate(requestParameters) {
        await this.deactivateRaw(requestParameters);
    }
    /**
     * Deploy a new SuperContract by a file path. Return the SuperContract ID.
     * Deploy a SuperContract
     */
    async deployRaw(requestParameters) {
        if (requestParameters.argDrive === null || requestParameters.argDrive === undefined) {
            throw new runtime.RequiredError('argDrive', 'Required parameter requestParameters.argDrive was null or undefined when calling deploy.');
        }
        if (requestParameters.argSrc === null || requestParameters.argSrc === undefined) {
            throw new runtime.RequiredError('argSrc', 'Required parameter requestParameters.argSrc was null or undefined when calling deploy.');
        }
        const queryParameters = {};
        queryParameters['arg'] = [requestParameters.argDrive, requestParameters.argSrc];
        const headerParameters = {};
        const response = await this.request({
            path: `/sc/deploy`,
            method: 'POST',
            headers: headerParameters,
            query: queryParameters,
        });
        return new runtime.JSONApiResponse(response, (jsonValue) => models_1.CidResultWrapFromJSON(jsonValue));
    }
    /**
     * Deploy a new SuperContract by a file path. Return the SuperContract ID.
     * Deploy a SuperContract
     */
    async deploy(requestParameters) {
        const response = await this.deployRaw(requestParameters);
        return await response.value();
    }
    /**
     * Start execution of a SuperContract. Return the Transaction ID.
     * Execute a SuperContract
     */
    async executeRaw(requestParameters) {
        if (requestParameters.argScId === null || requestParameters.argScId === undefined) {
            throw new runtime.RequiredError('argScId', 'Required parameter requestParameters.argScId was null or undefined when calling execute.');
        }
        if (requestParameters.argGas === null || requestParameters.argGas === undefined) {
            throw new runtime.RequiredError('argGas', 'Required parameter requestParameters.argGas was null or undefined when calling execute.');
        }
        if (requestParameters.argFuncName === null || requestParameters.argFuncName === undefined) {
            throw new runtime.RequiredError('argFuncName', 'Required parameter requestParameters.argFuncName was null or undefined when calling execute.');
        }
        const queryParameters = {};
        queryParameters['arg'] = [requestParameters.argScId, requestParameters.argGas, requestParameters.argFuncName];
        if (requestParameters.argArgsArray) {
            queryParameters['params'] = requestParameters.argArgsArray;
        }
        const headerParameters = {};
        const response = await this.request({
            path: `/sc/exec`,
            method: 'POST',
            headers: headerParameters,
            query: queryParameters,
        });
        return new runtime.JSONApiResponse(response, (jsonValue) => models_1.SupercontractExecFromJSON(jsonValue));
    }
    /**
     * Start execution of a SuperContract. Return the Transaction ID.
     * Execute a SuperContract
     */
    async execute(requestParameters) {
        const response = await this.executeRaw(requestParameters);
        return await response.value();
    }
    /**
     * Get all execution results started by a node. Returns Transaction IDs.
     * Execution results
     */
    async executionsRaw() {
        const queryParameters = {};
        const headerParameters = {};
        const response = await this.request({
            path: `/sc/executions`,
            method: 'POST',
            headers: headerParameters,
            query: queryParameters,
        });
        return new runtime.JSONApiResponse(response, (jsonValue) => models_1.ExecutionsWrapFromJSON(jsonValue));
    }
    /**
     * Get all execution results started by a node. Returns Transaction IDs.
     * Execution results
     */
    async executions() {
        const response = await this.executionsRaw();
        return await response.value();
    }
    /**
     * Get a SuperContract by ID.
     * Get a SuperContract
     */
    async getSCRaw(requestParameters) {
        if (requestParameters.argScId === null || requestParameters.argScId === undefined) {
            throw new runtime.RequiredError('argScId', 'Required parameter requestParameters.argScId was null or undefined when calling getSC.');
        }
        const queryParameters = {};
        queryParameters['arg'] = requestParameters.argScId;
        const headerParameters = {};
        const response = await this.request({
            path: `/sc/get`,
            method: 'POST',
            headers: headerParameters,
            query: queryParameters,
        });
        return new runtime.JSONApiResponse(response, (jsonValue) => models_1.SuperContractWrapFromJSON(jsonValue));
    }
    /**
     * Get a SuperContract by ID.
     * Get a SuperContract
     */
    async getSC(requestParameters) {
        const response = await this.getSCRaw(requestParameters);
        return await response.value();
    }
    /**
     * Get all SuperContract on a drive.
     * Get SuperContracts IDs
     */
    async lsSCRaw(requestParameters) {
        if (requestParameters.argDrive === null || requestParameters.argDrive === undefined) {
            throw new runtime.RequiredError('argDrive', 'Required parameter requestParameters.argDrive was null or undefined when calling lsSC.');
        }
        const queryParameters = {};
        queryParameters['arg'] = requestParameters.argDrive;
        const headerParameters = {};
        const response = await this.request({
            path: `/sc/ls`,
            method: 'POST',
            headers: headerParameters,
            query: queryParameters,
        });
        return new runtime.JSONApiResponse(response, (jsonValue) => models_1.CidListWrapFromJSON(jsonValue));
    }
    /**
     * Get all SuperContract on a drive.
     * Get SuperContracts IDs
     */
    async lsSC(requestParameters) {
        const response = await this.lsSCRaw(requestParameters);
        return await response.value();
    }
    /**
     * Get results of a SuperContract execution by its TxID.
     * Results of a SuperContract execution
     */
    async resultsRaw(requestParameters) {
        if (requestParameters.argTxId === null || requestParameters.argTxId === undefined) {
            throw new runtime.RequiredError('argTxId', 'Required parameter requestParameters.argTxId was null or undefined when calling results.');
        }
        const queryParameters = {};
        queryParameters['arg'] = requestParameters.argTxId;
        const headerParameters = {};
        const response = await this.request({
            path: `/sc/results`,
            method: 'POST',
            headers: headerParameters,
            query: queryParameters,
        });
        return new runtime.JSONApiResponse(response, (jsonValue) => models_1.ResultsWrapFromJSON(jsonValue));
    }
    /**
     * Get results of a SuperContract execution by its TxID.
     * Results of a SuperContract execution
     */
    async results(requestParameters) {
        const response = await this.resultsRaw(requestParameters);
        return await response.value();
    }
}
exports.SuperContractApi = SuperContractApi;
//# sourceMappingURL=SuperContractApi.js.map