/**
 * DFMS API
 * DFMS node HTTP API. [Reference implementation in GO](https://github.com/proximax-storage/go-xpx-dfms-api-http) [API definition](https://github.com/proximax-storage/go-xpx-dfms-api)  API does not tries to follow idiomatic REST or other API patterns for reasons.
 *
 * The version of the OpenAPI document: 1.0.0
 *
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
/**
 * Drive contract
 * @export
 * @interface Contract
 */
export interface Contract {
    /**
     * [Cid](https://github.com/multiformats/cid) (version 1) - special content identifier.
     * @type {string}
     * @memberof Contract
     */
    drive?: string;
    /**
     * Hex encoded public key.
     * @type {string}
     * @memberof Contract
     */
    owner?: string;
    /**
     * Hex encoded public keys.
     * @type {Array<string>}
     * @memberof Contract
     */
    replicators?: Array<string>;
    /**
     * [Cid](https://github.com/multiformats/cid) (version 1) - special content identifier.
     * @type {string}
     * @memberof Contract
     */
    root?: string;
    /**
     * Block height when the Contract was started.
     * @type {number}
     * @memberof Contract
     */
    created?: number;
    /**
     *
     * @type {number}
     * @memberof Contract
     */
    duration?: number;
    /**
     *
     * @type {number}
     * @memberof Contract
     */
    space?: number;
    /**
     *
     * @type {number}
     * @memberof Contract
     */
    replicas?: number;
    /**
     *
     * @type {number}
     * @memberof Contract
     */
    minReplicators?: number;
    /**
     *
     * @type {number}
     * @memberof Contract
     */
    percentApprovers?: number;
    /**
     *
     * @type {number}
     * @memberof Contract
     */
    billingPrice?: number;
    /**
     *
     * @type {number}
     * @memberof Contract
     */
    billingPeriod?: number;
}
export declare function ContractFromJSON(json: any): Contract;
export declare function ContractFromJSONTyped(json: any, ignoreDiscriminator: boolean): Contract;
export declare function ContractToJSON(value?: Contract | null): any;
